<?php
/**
* @author Mikko Rönkkö 
*/



defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_PLUGINS->registerFunction( 'onBeforeUserProfileDisplay', 'checkForConfigUpdates','privacyPolicy' );



class privacyPolicy extends cbPluginHandler{

	private $tab_plugins=null;
	
	function getDisplayTab($tab, $user, $ui) {

		
		global $_PLUGINS;
		global $database;	
		global $my;
		$results = null;
		
		

		$show=true;
		
		//Check the policy and modify $show
				
		if($my->id!=$user->id&&$ui=1){
		 	//This query fails if this is the original privacy policy tab, but this is semi-intentional 		
			$database->setQuery('select cb_privacypolicy_'.$tab->tabid.' from #__comprofiler where user_id='.$user->id);
			$policy=$database->loadResult();
			if($policy!=null){
				for($i=1;$i<=5;$i++){
					if($this->params->get("pol".$i."_title",'')==$policy){
						//We found the policy, lets continue
						
						$policySQL=$this->params->get("pol".$i."_sql",'');
						//Replace the userIDs
						$policySQL= str_replace('{$my}',$my->id,$policySQL);					
						$policySQL= str_replace('{$user}',$user->id,$policySQL);
					
						$database->setQuery($policySQL);
					
						//If we get a result, we lets show the tab 
						$show=($database->loadResult()==1);					
						break;	
					}
				}			
			}

		}	
		
		
		if($show==false){

			$tab->fields=false;
		
		}
		else{

			if($this->tab_plugins==null)
				$this->tab_plugins=$this->_initTabPlugins();
   		
			//If plugin, display it. If this is the originap privacy policy tab, it does not have original tab 
					
		 	if(array_key_exists($tab->tabid,$this->tab_plugins)){
		 		$origTab=$this->tab_plugins[$tab->tabid];

				if($origTab->pluginclass!=null){


					$pluginid=$origTab->pluginid;
					$pluginclass=$origTab->pluginclass;
		
        			if ( $pluginid && $pluginclass!='privacyPolicy') { //Safeguard against infinite regression
        				if($_PLUGINS->loadPluginGroup('user',array($pluginid))) {
	        				$args=array($tab , &$user, $ui);
	        				$results=$_PLUGINS->call($pluginid,'getDisplayTab',$pluginclass, $args, $tab->params);
						}	        		
	        		}
        		}
			}
							
		}
	   return $results;
				
	}
	
	function getEditTab($tab, $user, $ui) {
		return $this->callOriginal ($tab, $user, $ui,null,'getEditTab');
	}
	function getDisplayRegistration($tab, $user, $ui) {
		return $this->callOriginal ($tab, $user, $ui,null,'getDisplayRegistration');
	}
	function saveEditTab($tab, $user, $ui, $postdata) {
		return $this->callOriginal ($tab, $user, $ui,$postdata,'saveEditTab');
	}
	function saveRegistrationTab($tab, $user, $ui, $postdata) {
		return $this->callOriginal ($tab, $user, $ui,$postdata,'saveRegistrationTab');
	}

	function callOriginal($tab, $user, $ui,$postdata, $function) {

		global $_PLUGINS;
		global $database;	
		global $my;
		$results = null;
				
		if($this->tab_plugins==null)
			$this->tab_plugins=$this->_initTabPlugins();

		
   		
		//If plugin, display it		
		$origTab=$this->tab_plugins[$tab->tabid];
		 
		if($origTab->pluginclass!=null){


			$pluginid=$origTab->pluginid;
			$pluginclass=$origTab->pluginclass;
		
     		if ( $pluginid && $pluginclass!='privacyPolicy') { //Never recall privacy policy. Privacy policy fields are managed by CB, so there is no need to invoke plugin
	     		if($_PLUGINS->loadPluginGroup('user',array($pluginid))) {
	     			if($postdata==null)
	     				$args=array($tab , &$user, $ui);
					else
	     				$args=array($tab , &$user, $ui, $postdata);
						     			
	     			$results=$_PLUGINS->call($pluginid,$function,$pluginclass, $args, $tab->params);
	     		}
			}
							
		}
	   return $results;
				
	}


	function _initTabPlugins(){
		global $database;
		
		$returnArray=array();
		
		$database->setQuery("select * from #__comprofiler_tabs_backup");
		$results=$database->loadObjectList();
		
		foreach($results as $result){
			$returnArray[$result->tabid]=$result;			
		}
		return $returnArray;
	}
	function loadTabList($name,$value,$control_name) {
	
		global $database;

		$database->setQuery("select tabid, title from #__comprofiler_tabs");
		$tabs = $database->loadObjectList();
		$tabList = array();
	
		$tabList[] = mosHTML::makeOption(-1,'none');
		foreach ($tabs as $tab) {
				$tabList[] = mosHTML::makeOption( $tab->tabid, $tab->title);
		}
		$valAsObj = (isset($value)&&$value!='') ?
		array_map(create_function('$v', '$o=new stdClass(); $o->value=$v; return $o;'), explode("|*|", $value ))
		:$this->_getSelectedTabs();

		return moscomprofilerHTML::selectList( $tabList, $control_name .'['. $name .'][]', 'size="4" multiple="multiple"', 'value', 'text', $valAsObj, true );	
		
	}
	function _getSelectedTabs(){
	
		global $database;
	
		$database->setQuery("select tabid, title from #__comprofiler_tabs where pluginclass = 'privacypolicy'");
		$tabs = $database->loadObjectList();
		$tabList = array();
	
		foreach ($tabs as $tab) {
				$tabList[] = mosHTML::makeOption( $tab->tabid, null);
		}

		return $tabList;
	}

		function checkForConfigUpdates($a,$b,$c,$d){
		
		global $database;
		$database->setQuery("select count(id) from #__comprofiler_plugin where element='privacypolicy' and params like '%privacyEnabledTabs%'");

		if($database->loadResult()==1){
		//lets update the tabs

			
			$tabsToUpdate =  explode("|*|", $this->params->get('privacyEnabledTabs',''));
			$pluginId=$this->id;
			
			echo "<script type=\"text/javascript\"> alert('Privacy policy plugin updated');</script>\n";
	
			//Store all other parameters
			$paramNames= array("userCanConfigure","pol1_title","pol1_sql","enable_pol1",
				"pol2_title","pol2_sql","enable_pol2",
				"pol3_title","pol3_sql","enable_pol3",
				"pol4_title","pol4_sql","enable_pol4",
				"pol5_title","pol5_sql","enable_pol5",
				"defaultPolicy");
			
			$paramArray=array();
			
			foreach($paramNames as $paramName){
				array_push($paramArray,$paramName."=".$this->params->get($paramName,''));			
			}
			
			$sql="UPDATE #__comprofiler_plugin SET params ='".implode("\n",$paramArray)."'  where element='privacypolicy'";
			
			//debug echo ($sql."\n");			
		
			$database->SetQuery($sql);
			
			if (!$database->query()) {
				echo "<script type=\"text/javascript\"> alert('store:".
					$database->stderr(true)."'); window.history.go(-1);</script>\n";
			}

			//Move all original plugins back
			
			$sql="UPDATE #__comprofiler_tabs t, #__comprofiler_tabs_backup b SET t.pluginclass = b.pluginclass, t.pluginid = b.pluginid WHERE t.tabid = b.tabid";
				//debug echo ($sql."\n");			
		  
			$database->SetQuery($sql);
			
			if (!$database->query()) {
				echo "<script type=\"text/javascript\"> alert('store:".
					$database->stderr(true)."'); window.history.go(-1);</script>\n";
			}
			
			//Now the only privacy policy tab is the tab which should have privacy settings. Get the ID.

			$database->setQuery('select tabid from #__comprofiler_tabs where pluginclass="privacypolicy"');
			$privacyTabID=$database->loadResult();
			
						
			
			//Delete old backups
			$sql="DELETE FROM #__comprofiler_tabs_backup";
			
				//debug echo ($sql."\n");			
		
			$database->SetQuery($sql);
			
			if (!$database->query()) {
				echo "<script type=\"text/javascript\"> alert('store:".
					$database->stderr(true)."'); window.history.go(-1);</script>\n";
			}

			//Move all selected plugins to back-ups
			
		  $sql="INSERT INTO #__comprofiler_tabs_backup( pluginclass, pluginid, tabid )".
				"SELECT pluginclass, pluginid, tabid FROM jos_comprofiler_tabs WHERE tabid IN ("
					.implode(",",$tabsToUpdate). ")";

			$database->SetQuery($sql);
			
			if (!$database->query()) {
				echo "<script type=\"text/javascript\"> alert('store:".
					$database->stderr(true)."'); window.history.go(-1);</script>\n";
			}
			//Set Privacy Policy to control tabs
			
			$sql="UPDATE #__comprofiler_tabs SET pluginclass ='privacypolicy',".
				" pluginid=".$this->id." where tabid in (".implode(",",$tabsToUpdate).")";
				
				//debug echo ($sql."\n");			
		  
			$database->SetQuery($sql);
			
			if (!$database->query()) {
				echo "<script type=\"text/javascript\"> alert('store:".
					$database->stderr(true)."'); window.history.go(-1);</script>\n";
			}


			//Now lets prepare comprofieler, comprofiler_fields and comprofiler_field_values
			
			$userControlledTabs =  explode("|*|", $this->params->get('userCanConfigure',''));
			
			$defaultPolicyValue = $this->params->get("pol".$this->params->get("defaultPolicy")."_title");
			
			
			foreach($tabsToUpdate as $tab){
			
		
				
				if(in_array($tab,$userControlledTabs)){
					//Prepare user controlled tabs
					
					//set all null values to default
					$sql="update #__comprofiler set cb_privacypolicy_".$tab." = \"".$defaultPolicyValue.
						"\" where cb_privacypolicy_".$tab." is null";
					$database->setQuery($sql);
					$database->query();

					//create or update fields 
					$sql="select fieldid from #__comprofiler_fields where name=\"cb_privacypolicy_".$tab."\"";
					$database->setQuery($sql);
					$fieldId=$database->loadResult();
					
					if($fieldId==null){
						//If fields are not found, create them
						$sql="INSERT INTO `jos_comprofiler_fields` ".
						"(`name`, `table`, `title`, `description`, `type`, `maxlength`, `size`, `required`, `tabid`, `ordering`, `cols`, `rows`, `value`, `default`, `published`, `registration`, `profile`, `readonly`, `calculated`, `sys`) VALUES ".
						"('cb_privacypolicy_".$tab."', '#__comprofiler', '_UE_cb_policy_for_".$tab."', '_UE_policy_for_".$tab."_desc', ".
																					"'radio', 0, 0, 0, ".$privacyTabID.", 99, 0, 0, NULL, NULL, 1, 0,0, 0, 0, 0);";
						$database->setQuery($sql);
						$database->query();

						$sql="select fieldid #__comprofiler_fields where name=\"cb_privacypolicy_".$tab."\"";
						$database->setQuery($sql);
						$fieldId=$database->loadResult();
						
						//Add column to comprofiler for storing data
						
						$sql="ALTER TABLE #__comprofiler ADD cb_privacypolicy_".$tab." VARCHAR(255)";
						$database->setQuery($sql);
						$database->query();
					
					}
					//Then prepare values - star by removing old
						$sql="delete from `jos_comprofiler_field_values` where fieldid=".$fieldId;
						$database->setQuery($sql);
						$database->query();
					
					//Insert new values
					$legalValues=array();
					for($i=1;$i<=5;$i+=1){
						if($this->params->get("enablepol".$i,'')=='1'){
								$temp=$this->params->get("pol".$i."_title",'');
							$sql="insert into `jos_comprofiler_field_values` (fieldid, fieldtitle) values (".$fieldId.",'".$temp."')";;
		
							$database->setQuery($sql);
							$database->query();
							
							
							array_push($legalValues,"\"".$this->params->get("pol".$i."_title",'')."\"");
						}
					}
					//set illegal values to default

					$sql="update #__comprofiler set cb_privacypolicy_".$tab." = \"".$defaultPolicyValue.
						"\" where cb_privacypolicy_".$tab." not in (".implode(',',$legalValues).")";
					$database->setQuery($sql);
					$database->query();					
				
				}
				else{
					//Set default policy
					$sql="update #__comprofiler set cb_privacypolicy_".$tab." = \"".$defaultPolicyValue."\"";
					$database->setQuery($sql);
					$database->query();					
					
					//If any fields exists for this tab, delete.
					
					$sql="select fieldid #__comprofiler_fields where name=\"cb_privacypolicy_".$tab."\"";
					$database->setQuery($sql);
					$fieldid=$database->loadResult();
					
					if($fieldId!=null){
						//If fields are found, delete them
						$sql="delete from #__comprofiler_field_values where fieldid=".$fieldid;
						$database->setQuery($sql);
						$database->query();					
						$sql="delete from #__comprofiler_fields where fieldid=".$fieldid;
						$database->setQuery($sql);
						$database->query();					
					}					

				}
			}
		}
	}

}


?>
